<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/convert_authorization_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/05/82  convert_authorization_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The convert_authorization_ subroutine is provided to convert an
<span id="L4" class="LineNr">  4 </span>authorization in the Multics access isolation mechanism <span class="textRainbow_lv0_p0">(</span>AIM<span class="textRainbow_lv0_p0">)</span> back and
<span id="L5" class="LineNr">  5 </span>forth between its binary and character-string representations.
<span id="L6" class="LineNr">  6 </span>Additional entries provide the ability to encode an authorization as a
<span id="L7" class="LineNr">  7 </span>short character string for use in entrynames.
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Entry points in convert_authorization_:
<span id="L11" class="LineNr"> 11 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>:Entry: decode:  01/27/82  convert_authorization_$decode
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>Function:  This entry point takes the character string produced by the
<span id="L18" class="LineNr"> 18 </span>convert_authorization_$encode entry point and returns the original
<span id="L19" class="LineNr"> 19 </span>authorization or access class.  The null string is converted to the
<span id="L20" class="LineNr"> 20 </span>system_low authorization.
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>Syntax:
<span id="L24" class="LineNr"> 24 </span>declare convert_authorization_$decode entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L25" class="LineNr"> 25 </span>call convert_authorization_$decode <span class="textRainbow_lv0_p0">(</span>authorization<span class="textRainbow_lv0_o0">,</span> decoded_string<span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Arguments:
<span id="L29" class="LineNr"> 29 </span>authorization
<span id="L30" class="LineNr"> 30 </span>   is the the decoded authorization.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L31" class="LineNr"> 31 </span>decoded_string
<span id="L32" class="LineNr"> 32 </span>   is a short string <span class="textRainbow_lv0_p0">(</span>maximum of 15 characters<span class="textRainbow_lv0_p0">)</span> that uniquely
<span id="L33" class="LineNr"> 33 </span>   represents the input authorization/access class.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>:Entry: encode:  01/27/82  convert_authorization_$encode
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>Function:  This entry point encodes an authorization or access class
<span id="L40" class="LineNr"> 40 </span>into a short character string, suitable for inclusion in entrynames.
<span id="L41" class="LineNr"> 41 </span>If the input authorization represents system_low, the returned string
<span id="L42" class="LineNr"> 42 </span>is blank.
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>Syntax:
<span id="L46" class="LineNr"> 46 </span>declare convert_authorization_$encode entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L47" class="LineNr"> 47 </span>call convert_authorization_$encode <span class="textRainbow_lv0_p0">(</span>authorization<span class="textRainbow_lv0_o0">,</span> encoded_string<span class="textRainbow_lv0_p0">)</span>;
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>Arguments:
<span id="L51" class="LineNr"> 51 </span>authorization
<span id="L52" class="LineNr"> 52 </span>   is the input authorization.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L53" class="LineNr"> 53 </span>encoded_string
<span id="L54" class="LineNr"> 54 </span>   is a short string <span class="textRainbow_lv0_p0">(</span>maximum of 15 characters<span class="textRainbow_lv0_p0">)</span> that uniquely
<span id="L55" class="LineNr"> 55 </span>   represents the input authorization/access class.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>:Entry: from_string:  01/27/82  convert_authorization_$from_string
<span id="L59" class="LineNr"> 59 </span>
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>Function:  This entry point converts a character string to an encoded
<span id="L62" class="LineNr"> 62 </span>binary form suitable for storage in system tables and as input to the
<span id="L63" class="LineNr"> 63 </span>various modules that accept the binary form.
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>Syntax:
<span id="L67" class="LineNr"> 67 </span>declare convert_authorization_$from_string entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L68" class="LineNr"> 68 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L69" class="LineNr"> 69 </span>call convert_authorization_$from_string <span class="textRainbow_lv0_p0">(</span>authorization<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L70" class="LineNr"> 70 </span>
<span id="L71" class="LineNr"> 71 </span>
<span id="L72" class="LineNr"> 72 </span>Arguments:
<span id="L73" class="LineNr"> 73 </span>authorization
<span id="L74" class="LineNr"> 74 </span>   is the binary representation of string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L75" class="LineNr"> 75 </span>string
<span id="L76" class="LineNr"> 76 </span>   is the character string to be converted <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L77" class="LineNr"> 77 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L78" class="LineNr"> 78 </span>code
<span id="L79" class="LineNr"> 79 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It may be one of the following:
<span id="L80" class="LineNr"> 80 </span>   error_table_$ai_invalid_string
<span id="L81" class="LineNr"> 81 </span>        one or more namei is misspelled <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L82" class="LineNr"> 82 </span>   error_table_$ai_above_allowed_max
<span id="L83" class="LineNr"> 83 </span>        no error in conversion; but the resulting authorization class
<span id="L84" class="LineNr"> 84 </span>        is greater than the system_high authorization.
<span id="L85" class="LineNr"> 85 </span>
<span id="L86" class="LineNr"> 86 </span>
<span id="L87" class="LineNr"> 87 </span>Notes:  The string argument must be of the form--
<span id="L88" class="LineNr"> 88 </span>          name1,name2,...,nameN
<span id="L89" class="LineNr"> 89 </span>where nameI represents the mnemonic for a sensitivity level or access
<span id="L90" class="LineNr"> 90 </span>category.  The print_auth_names command <span class="textRainbow_lv0_p0">(</span>described in the MPM Commands<span class="textRainbow_lv0_p0">)</span>
<span id="L91" class="LineNr"> 91 </span>may be used to obtain a list of acceptable mnenomics.  If the string
<span id="L92" class="LineNr"> 92 </span>argument is null or system_low, the resulting authorization is level 0
<span id="L93" class="LineNr"> 93 </span>and no categories.  If the string is system_high, the system
<span id="L94" class="LineNr"> 94 </span>access_ceiling is returned <span class="textRainbow_lv0_p0">(</span>the maximum authorization or access class
<span id="L95" class="LineNr"> 95 </span>allowed<span class="textRainbow_lv0_p0">)</span>.
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>:Entry:  from_string_range:  01/27/82  convert_authorization_$from_string_range
<span id="L99" class="LineNr"> 99 </span>
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>Function:  This entry point converts a character string to the form of
<span id="L102" class="LineNr">102 </span>a binary authorization range.
<span id="L103" class="LineNr">103 </span>
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span>Syntax:
<span id="L106" class="LineNr">106 </span>declare convert_authorization_$from_string_range entry <span class="textRainbow_lv0_p0">(</span>bit <span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span>
<span id="L107" class="LineNr">107 </span>     aligned dimension <span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L108" class="LineNr">108 </span>call convert_authorization_$from_string <span class="textRainbow_lv0_p0">(</span>authorization_range<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span>
<span id="L109" class="LineNr">109 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span>Arguments:
<span id="L113" class="LineNr">113 </span>authorization_range
<span id="L114" class="LineNr">114 </span>   is the binary representation of string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L115" class="LineNr">115 </span>string
<span id="L116" class="LineNr">116 </span>   is the character string to be converted <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L117" class="LineNr">117 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L118" class="LineNr">118 </span>code
<span id="L119" class="LineNr">119 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It may be one of the following:
<span id="L120" class="LineNr">120 </span>   error_table_$ai_invalid_string
<span id="L121" class="LineNr">121 </span>        one or more nameI are misspelled <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.
<span id="L122" class="LineNr">122 </span>   error_table_$ai_above_allowed_max
<span id="L123" class="LineNr">123 </span>        no error in conversion; but the resulting authorization is
<span id="L124" class="LineNr">124 </span>        greater than the system_high authorization.
<span id="L125" class="LineNr">125 </span>   error_table_$ai_invalid_range
<span id="L126" class="LineNr">126 </span>        no error in conversion; but authorization_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> does not
<span id="L127" class="LineNr">127 </span>        represent an authorization greater than or equal to
<span id="L128" class="LineNr">128 </span>        authorization_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>.
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>Notes:  The string must be one of the two forms--
<span id="L132" class="LineNr">132 </span>          name1,name2,...,nameN
<span id="L133" class="LineNr">133 </span>          name1a,name2a,...,nameNa:name1b,name2b,...nameNb
<span id="L134" class="LineNr">134 </span>where nameI represents the mnemonic for a sensitivity level or access
<span id="L135" class="LineNr">135 </span>category.  If the string is in the first form, both elements of
<span id="L136" class="LineNr">136 </span>authorization_range will be set to equal values <span class="textRainbow_lv0_p0">(</span>similar to the
<span id="L137" class="LineNr">137 </span>operation of convert_authorization_$from_string<span class="textRainbow_lv0_p0">)</span>.  If string is in the
<span id="L138" class="LineNr">138 </span>second form, authorization_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> will be returned as the binary
<span id="L139" class="LineNr">139 </span>representation of the part of string left of the colon, and
<span id="L140" class="LineNr">140 </span>authorization_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> will be returned as the binary representation
<span id="L141" class="LineNr">141 </span>of the part of the string right of the colon.
<span id="L142" class="LineNr">142 </span>
<span id="L143" class="LineNr">143 </span>
<span id="L144" class="LineNr">144 </span>:Entry: minimum:  01/27/82  convert_authorization_$minimum
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Function:  This entry point accepts an array of authorizations or
<span id="L148" class="LineNr">148 </span>access classes and a binary number indicating how many elements to
<span id="L149" class="LineNr">149 </span>process from the array.  It returns an authorization/access class whose
<span id="L150" class="LineNr">150 </span>category set is the intersection of all input category sets and whose
<span id="L151" class="LineNr">151 </span>sensitivity level is the minimum of all input sensitivity levels.  The
<span id="L152" class="LineNr">152 </span>returned value need not equal any of the input values.
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>Syntax:
<span id="L156" class="LineNr">156 </span>declare convert_authorization_$minimum entry <span class="textRainbow_lv0_p0">(</span>dim<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L157" class="LineNr">157 </span>     fixed bin<span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_p0">)</span>;
<span id="L158" class="LineNr">158 </span>call convert_authorization_$minimum <span class="textRainbow_lv0_p0">(</span>auth_array<span class="textRainbow_lv0_o0">,</span> n_elements<span class="textRainbow_lv0_o0">,</span>
<span id="L159" class="LineNr">159 </span>     minimum_auth<span class="textRainbow_lv0_p0">)</span>;
<span id="L160" class="LineNr">160 </span>
<span id="L161" class="LineNr">161 </span>
<span id="L162" class="LineNr">162 </span>Arguments:
<span id="L163" class="LineNr">163 </span>auth_array
<span id="L164" class="LineNr">164 </span>   are the input authorizations.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L165" class="LineNr">165 </span>n_elements
<span id="L166" class="LineNr">166 </span>   is the number of elements to be processed in the auth_array
<span id="L167" class="LineNr">167 </span>   argument.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L168" class="LineNr">168 </span>minimum_auth
<span id="L169" class="LineNr">169 </span>   is the result.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>:Entry: to_string:  01/27/82  convert_authorization_$to_string
<span id="L173" class="LineNr">173 </span>
<span id="L174" class="LineNr">174 </span>
<span id="L175" class="LineNr">175 </span>Function:  This entry point accepts a binary form of an authorization
<span id="L176" class="LineNr">176 </span>and returns it as a printable string.  This output string is suitable
<span id="L177" class="LineNr">177 </span>for input to the convert_authorization_$from_string entry point.  Each
<span id="L178" class="LineNr">178 </span>level/category name has a maximum length of 32 characters.
<span id="L179" class="LineNr">179 </span>
<span id="L180" class="LineNr">180 </span>
<span id="L181" class="LineNr">181 </span>Syntax:
<span id="L182" class="LineNr">182 </span>declare convert_authorization_$to_string entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L183" class="LineNr">183 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L184" class="LineNr">184 </span>call convert_authorization_$to_string <span class="textRainbow_lv0_p0">(</span>authorization<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L185" class="LineNr">185 </span>
<span id="L186" class="LineNr">186 </span>
<span id="L187" class="LineNr">187 </span>Arguments:
<span id="L188" class="LineNr">188 </span>authorization
<span id="L189" class="LineNr">189 </span>   is the binary representation of string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L190" class="LineNr">190 </span>string
<span id="L191" class="LineNr">191 </span>   is the character string to be converted.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L192" class="LineNr">192 </span>code
<span id="L193" class="LineNr">193 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It may be one of the following:
<span id="L194" class="LineNr">194 </span>   error_table_$smallarg
<span id="L195" class="LineNr">195 </span>        string is too short to hold the converted result <span class="textRainbow_lv0_p0">(</span>see &quot;Notes&quot;
<span id="L196" class="LineNr">196 </span>        below<span class="textRainbow_lv0_p0">)</span>.
<span id="L197" class="LineNr">197 </span>   error table_$ai_invalid binary
<span id="L198" class="LineNr">198 </span>        either the level number or category set is invalid; the
<span id="L199" class="LineNr">199 </span>        resulting output is also invalid.
<span id="L200" class="LineNr">200 </span>
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>Notes:  When the error_table_$smallarg code is returned, as much of the
<span id="L203" class="LineNr">203 </span>resulting conversion as fits in the output string is returned.
<span id="L204" class="LineNr">204 </span>However, since the results are not complete, they should not be used as
<span id="L205" class="LineNr">205 </span>input to the convert_authorization_$from_string entry point.
<span id="L206" class="LineNr">206 </span>
<span id="L207" class="LineNr">207 </span>
<span id="L208" class="LineNr">208 </span>:Entry:  to_string_range:  01/27/82  convert_authorization_$to_string_range
<span id="L209" class="LineNr">209 </span>
<span id="L210" class="LineNr">210 </span>
<span id="L211" class="LineNr">211 </span>Function:  This entry point accepts a binary authorization range pair
<span id="L212" class="LineNr">212 </span>and returns it as a printable string.  This output string is suitable
<span id="L213" class="LineNr">213 </span>for input to the convert_authorization_$from_string_range entry point.
<span id="L214" class="LineNr">214 </span>Each level/category name has a maximum length of 32 characters.
<span id="L215" class="LineNr">215 </span>
<span id="L216" class="LineNr">216 </span>
<span id="L217" class="LineNr">217 </span>Syntax:
<span id="L218" class="LineNr">218 </span>declare convert_authorization_$to_string_range entry <span class="textRainbow_lv0_p0">(</span>bit <span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned
<span id="L219" class="LineNr">219 </span>     dimension <span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L220" class="LineNr">220 </span>call convert_authorization_$to_string_range <span class="textRainbow_lv0_p0">(</span>authorization_range<span class="textRainbow_lv0_o0">,</span>
<span id="L221" class="LineNr">221 </span>     string<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L222" class="LineNr">222 </span>
<span id="L223" class="LineNr">223 </span>
<span id="L224" class="LineNr">224 </span>Arguments:
<span id="L225" class="LineNr">225 </span>authorization_range
<span id="L226" class="LineNr">226 </span>   is the binary representation of an authorization range to be
<span id="L227" class="LineNr">227 </span>   converted.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L228" class="LineNr">228 </span>string
<span id="L229" class="LineNr">229 </span>   is the resultant character string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L230" class="LineNr">230 </span>code
<span id="L231" class="LineNr">231 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It may be one of the following:
<span id="L232" class="LineNr">232 </span>   error_table_$smallarg
<span id="L233" class="LineNr">233 </span>        string is too short to hold the converted result.
<span id="L234" class="LineNr">234 </span>   error_table_$ai_invalid_binary
<span id="L235" class="LineNr">235 </span>        either the level number or category set is invalid; the
<span id="L236" class="LineNr">236 </span>        resulting output is also invalid.
<span id="L237" class="LineNr">237 </span>   error_table_$ai_invalid_range
<span id="L238" class="LineNr">238 </span>        no error in conversion; but authorization_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> does not
<span id="L239" class="LineNr">239 </span>        represent an authorization greater than or equal to
<span id="L240" class="LineNr">240 </span>        authorization_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>.
<span id="L241" class="LineNr">241 </span>
<span id="L242" class="LineNr">242 </span>
<span id="L243" class="LineNr">243 </span>Notes:  When the error_table_$smallarg code is returned, as much of the
<span id="L244" class="LineNr">244 </span>resulting conversion as fits in the output string is returned.
<span id="L245" class="LineNr">245 </span>However, since the results are not complete, they should not be used as
<span id="L246" class="LineNr">246 </span>input to the convert_authorization_$from_string entry point.
<span id="L247" class="LineNr">247 </span>
<span id="L248" class="LineNr">248 </span>
<span id="L249" class="LineNr">249 </span>:Entry:  to_string_range_short:  01/27/82  convert_authorization_$to_string_range_short
<span id="L250" class="LineNr">250 </span>
<span id="L251" class="LineNr">251 </span>
<span id="L252" class="LineNr">252 </span>Function:  This entry point is identical to the
<span id="L253" class="LineNr">253 </span>convert_authorization_$to_string_range entry point except that the
<span id="L254" class="LineNr">254 </span>short level/category names are returned.  Each short name has a maximum
<span id="L255" class="LineNr">255 </span>length of eight characters.  This output is also suitable for input to
<span id="L256" class="LineNr">256 </span>the convert_authorization_$from_string_range entry point.
<span id="L257" class="LineNr">257 </span>
<span id="L258" class="LineNr">258 </span>
<span id="L259" class="LineNr">259 </span>Syntax:
<span id="L260" class="LineNr">260 </span>declare convert_authorization_$to_string_range_short entry bit <span class="textRainbow_lv0_p0">(</span>72<span class="textRainbow_lv0_p0">)</span>
<span id="L261" class="LineNr">261 </span>     aligned dimension <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span>, char<span class="textRainbow_lv0_p0">(</span>*<span class="textRainbow_lv0_p0">)</span>, fixed bin<span class="textRainbow_lv0_p0">(</span>35<span class="textRainbow_lv0_p0">)</span>;
<span id="L262" class="LineNr">262 </span>call convert_authorization_$to_string_range_short <span class="textRainbow_lv0_p0">(</span>authorization_range<span class="textRainbow_lv0_o0">,</span>
<span id="L263" class="LineNr">263 </span>     string<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>
<span id="L264" class="LineNr">264 </span>
<span id="L265" class="LineNr">265 </span>
<span id="L266" class="LineNr">266 </span>Arguments:
<span id="L267" class="LineNr">267 </span>authorization_range
<span id="L268" class="LineNr">268 </span>   is the binary representation of an authorization range to be
<span id="L269" class="LineNr">269 </span>   converted.
<span id="L270" class="LineNr">270 </span>    <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L271" class="LineNr">271 </span>string
<span id="L272" class="LineNr">272 </span>   is the resultant character string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L273" class="LineNr">273 </span>code
<span id="L274" class="LineNr">274 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It may be one of the following:
<span id="L275" class="LineNr">275 </span>   error_table_$smallarg
<span id="L276" class="LineNr">276 </span>        string is too short to hold the converted result.
<span id="L277" class="LineNr">277 </span>   error_table_$ai_invalid_binary
<span id="L278" class="LineNr">278 </span>        either the level number or category set is invalid; the
<span id="L279" class="LineNr">279 </span>        resulting output is also invalid.
<span id="L280" class="LineNr">280 </span>   error_table_$ai_invalid_range
<span id="L281" class="LineNr">281 </span>        no error in conversion; but authorization_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> does not
<span id="L282" class="LineNr">282 </span>        represent an authorization greater than or equal to
<span id="L283" class="LineNr">283 </span>        authorization_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>.
<span id="L284" class="LineNr">284 </span>
<span id="L285" class="LineNr">285 </span>
<span id="L286" class="LineNr">286 </span>:Entry:  to_string_short:  01/27/82  convert_authorization_$to_string_short
<span id="L287" class="LineNr">287 </span>
<span id="L288" class="LineNr">288 </span>
<span id="L289" class="LineNr">289 </span>Function:  This entry point is identical to the
<span id="L290" class="LineNr">290 </span>convert_authorization_$to_string entry point, except that the short
<span id="L291" class="LineNr">291 </span>level/category names are returned.  Each short name has a maximum
<span id="L292" class="LineNr">292 </span>length of eight characters.  This output is also suitable for input to
<span id="L293" class="LineNr">293 </span>the convert_authorization_$from_string entry point.
<span id="L294" class="LineNr">294 </span>
<span id="L295" class="LineNr">295 </span>
<span id="L296" class="LineNr">296 </span>Syntax:
<span id="L297" class="LineNr">297 </span>declare convert_authorization_$to_string_short entry <span class="textRainbow_lv0_p0">(</span>bit<span class="textRainbow_lv1_p0">(</span>72<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L298" class="LineNr">298 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L299" class="LineNr">299 </span>call convert_authorization_$to_string_short <span class="textRainbow_lv0_p0">(</span>authorization<span class="textRainbow_lv0_o0">,</span> string<span class="textRainbow_lv0_o0">,</span>
<span id="L300" class="LineNr">300 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L301" class="LineNr">301 </span>
<span id="L302" class="LineNr">302 </span>
<span id="L303" class="LineNr">303 </span>Arguments:
<span id="L304" class="LineNr">304 </span>authorization
<span id="L305" class="LineNr">305 </span>   is the binary representation of string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L306" class="LineNr">306 </span>string
<span id="L307" class="LineNr">307 </span>   is the character string to be converted.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L308" class="LineNr">308 </span>code
<span id="L309" class="LineNr">309 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span> It may be one of the following:
<span id="L310" class="LineNr">310 </span>   error_table_$smallarg
<span id="L311" class="LineNr">311 </span>        string is too short to hold the converted result.
<span id="L312" class="LineNr">312 </span>   error_table_$ai_invalid_binary
<span id="L313" class="LineNr">313 </span>        either the level number or category set is invalid; the
<span id="L314" class="LineNr">314 </span>        resulting output is also invalid.
<span id="L315" class="LineNr">315 </span>   error_table_$ai_invalid_range
<span id="L316" class="LineNr">316 </span>        no error in conversion; but authorization_range <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> does not
<span id="L317" class="LineNr">317 </span>        represent an authorization greater than or equal to
<span id="L318" class="LineNr">318 </span>        authorization_range <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
